<template>
    <n-modal
        v-model:show="modalSettings.show"
        :style="{ width: modalSettings.width >= 600 ? modalSettings.width + 'px': '600px'}">

        <!-- ШАПКА ПОПАПА -->
        <template #header>
            <!-- // название события -->
            <div class="modal__title title">
                <span class="title__text">{{this.modalData.modalTitle}}</span>
            </div>
            <!-- // описание события -->
            <div class="modal__description">
                <p>
                    {{this.modalData.modalDescription}}
                </p>
            </div>
        </template>

        <!-- ТЕЛО ПОПАПА -->
        <!-- // данные по игрокам -->
        <div class="modal__users">
            <div class="users__list">
                <div class="users__item" v-for="user in this.modalData.users">
                    <!-- // аватарка пользователя -->
                    <div class="users__media" v-html=user.ico>
                    </div>
                    <!-- // тайтл пользователя -->
                    <div class="users__title title">
                        <span class="title__text">{{user.title}}</span>
                    </div>
                </div>
            </div>
        </div>

        <!-- // время до начала сражения -->
        <div class="modal__time time">
            <span class="time__title">{{this.modalData.time.title}}</span>
            <span class="time__value">{{this.modalData.time.value}}</span>
        </div>

        <!-- // адрес сражения -->
        <div class="modal__address address">
            <svg class="address__ico" width="12" height="16" viewBox="0 0 12 16" fill="none"
                 xmlns="http://www.w3.org/2000/svg">
                <g clip-path="url(#clip0_1_69)">
                    <path fill-rule="evenodd" clip-rule="evenodd"
                          d="M5.49892 8.41968C4.30844 8.41968 3.34559 7.45684 3.34559 6.26635C3.34559 5.07587 4.30844 4.11303 5.49892 4.11303C6.6894 4.11303 7.65225 5.07587 7.65225 6.26635C7.65225 7.45684 6.6894 8.41968 5.49892 8.41968ZM5.20973 0.889295C2.59498 1.02772 0.41704 3.07646 0.146336 5.66353C0.0109838 6.95245 0.340135 8.15524 0.983057 9.13961L4.97902 15.3658C5.22203 15.7442 5.77575 15.7442 6.01877 15.3658L10.0147 9.13961C10.5623 8.30289 10.8822 7.30621 10.8822 6.2357C10.8822 3.18413 8.3136 0.729334 5.20973 0.889295Z"
                          fill="#9B9B9B"/>
                </g>
                <defs>
                    <clipPath id="clip0_1_69">
                        <rect width="11" height="16" fill="white" transform="translate(0 0.5)"/>
                    </clipPath>
                </defs>
            </svg>
            <span class="address__text">{{this.modalData.address}}</span>
        </div>

        <!-- ПОДВАЛ ПОПАПА -->
        <template #footer>
            <!-- // выполнить действие в попапе -->
            <div class="modal__action action">
                <span class="action__btn btn"
                      @click="$emit('successEmit' , 'Пользователь дал согласие на действие')">
                  <span class="btn__text">{{this.modalData.action.text}}</span>
                </span>
            </div>
        </template>
    </n-modal>
</template>

<script>
    export default {
        props: ["modalSettings", "modalData"],
        watch: {
            // Следим за состоянием попапа, если попап закрыли, то отправляем emit
            "modalSettings.show": function (val) {
                if (val === false) {
                    this.$emit('cancelEmit', 'Пользователь закрыл попап')
                }
            },
        },
    }
</script>

<style lang="sass" scoped>
    @import "../assets/scss/helper/variables"
    @import "../assets/scss/helper/media"
    /* Стилизация кастомного модального окна */
    .modal_custom
        // modal__title
        .modal__title
            &:not(:last-child)
                margin-bottom: .6rem
            .title__text
                color: $colorPrimary100
                font-size: 1.75rem
                line-height: 1.75rem
                font-weight: 700
        // modal__description
        .modal__description
            color: $colorPrimary300
            font-size: .875rem
            line-height: 1rem
            font-weight: 700
            &:not(:last-child)
                margin-bottom: .5rem

        // modal__users
        .modal__users
            &:not(:last-child)
                margin-bottom: 2.2rem

            .users__list
                display: flex
                justify-content: space-between
                position: relative
                @include mediaMinWidthMobile
                &:before
                    content: ""
                    width: 12rem
                    height: 12rem
                    background: url('../assets/img/content/modal/modalVs.png') center  no-repeat
                    background-size: cover
                    position: absolute
                    top: -2rem
                    left: 50%
                    @include transition
                    margin-left: -6rem
                    animation: size 3s ease-in-out infinite
                    @keyframes size
                        0%
                            transform: scale(1)
                        50%
                            transform: scale(1.1)
                        100%
                            transform: scale(1)
            .users__item
                display: flex
                flex-direction: column
                align-items: center
                max-width: 9.2rem

                .users__media
                    width: 7.75rem
                    height: 7.75rem
                    border-radius: 50%
                    display: flex
                    justify-content: center
                    align-items: center

                    &:not(:last-child)
                        margin-bottom: 1.5rem

                .users__title
                    .title__text
                        color: $colorPrimary100
                        font-weight: 700
                        font-size: 1rem
                        line-height: 1.25rem

        // modal time
        .modal__time
            display: flex
            flex-direction: column

            &:not(:last-child)
                margin-bottom: 1.75rem

            .time__title
                color: $colorPrimary200
                font-weight: 700
                text-transform: uppercase

            .time__value
                color: $colorPrimary100
                font-size: 2rem
                line-height: 2.4rem
                font-weight: 700
        // modal address
        .modal__address
            color: $colorPrimary300
            display: flex
            align-items: center
            justify-content: center
            font-weight: 700

            &:not(:last-child)
                margin-bottom: 1.5rem

            .address__ico
                width: .75rem
                min-width: .75rem
                height: auto
                margin-right: .5rem

        // modal__action
        .modal__action
            display: flex
            justify-content: center

            .action__btn
                color: $colorPrimary100
                font-weight: 700
                padding: 1.125rem 2rem
                box-sizing: border-box
                text-transform: uppercase
                cursor: pointer
                position: relative

                &:before,
                &:after
                    content: ""
                    position: absolute
                    left: 0
                    right: 0
                    top: 0
                    bottom: 0
                    border-radius: 10px
                    transform: skew(-10deg)
                    @include transition

                &:before
                    top: 8%
                    bottom: 0
                    background: #4D0802

                &:after
                    bottom: 8%
                    background: linear-gradient(180deg, #FF5951 -19.17%, #660D05 100%)

                .btn__text
                    position: relative
                    z-index: 2
</style>